
// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "FDExtCaptureAsync.h"
#include "ChildView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CChildView
BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
END_MESSAGE_MAP()
//
bool CChildView::SetUYVY(BYTE *data, int stride, int dx, int dy)
{
	// check buffer size
	int size = dx * dy;
	if (size > m_nImageSize) {
		if (nullptr != m_pImage) {
			m_nImageSize = 0;
			delete[] m_pImage;
		}
		m_pImage = new COLORREF[size];
		if (nullptr == m_pImage)
			return false;
		m_nImageSize = size;
	}
	// convert image from UYVY to COLORREF
	COLORREF *to = &m_pImage[(dy - 1) * dx];
	BYTE *from = data;
	for (int y = 0; y < dy; y++) {
		for (int x = 0; x < dx; x += 2) { // 2 pixels
			BYTE uu = from[x * 2 + 0];
			BYTE y0 = from[x * 2 + 1];
			BYTE vv = from[x * 2 + 2];
			BYTE y1 = from[x * 2 + 3];
			to[x + 0] = RGB(y0, y0, y0);
			to[x + 1] = RGB(y1, y1, y1);
		}
		from += stride;
		to -= dx;
	}
	// all done
	m_nDX = dx;
	m_nDY = dy;
	Invalidate(FALSE);
	return true;
}
//
BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(nullptr, IDC_ARROW), reinterpret_cast<HBRUSH>(COLOR_WINDOW+1), nullptr);

	return TRUE;
}
//
void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	if (nullptr != m_pImage) {
		BITMAPINFOHEADER hd;  ZeroMemory(&hd, sizeof(hd));
		hd.biSize = sizeof(hd);
		hd.biWidth = m_nDX;
		hd.biHeight = m_nDY;
		hd.biBitCount = 32;
		hd.biPlanes = 1;
		SetDIBitsToDevice(dc, 0, 0, m_nDX, m_nDY, 0, 0, 0, m_nDY, m_pImage, (BITMAPINFO*)&hd, DIB_RGB_COLORS);
	}
	// Do not call CWnd::OnPaint() for painting messages
}

